#undef __NO_VERSION__
#include <linux/version.h>

#include <linux/string.h>
#include <linux/errno.h>
#ifdef MODULE
   #if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
      #define MODVERSIONS
   #endif

   #ifdef MODVERSIONS
      #include <config/modversions.h>
   #endif

   #include <linux/module.h>
#endif

#include "nikal.h"

#ifdef MODULE_LICENSE
   #ifdef nNIKAL100_kCopyrightString
      MODULE_LICENSE(nNIKAL100_kCopyrightString);
   #endif
#endif

#ifdef MODULE_AUTHOR
   #ifdef nNIKAL100_kAuthorString
      MODULE_AUTHOR(nNIKAL100_kAuthorString);
   #endif
#endif

#ifdef MODULE_DESCRIPTION
   #ifdef nNIKAL100_kDescriptionString
      MODULE_DESCRIPTION(nNIKAL100_kDescriptionString);
   #endif
#endif


#include <linux/mod_devicetable.h>

int nNIAPAL200_driverEntry(struct nNIKAL100_tDriver *driver);

static struct nNIKAL100_tDriver atomicDriver;
static void* nativeDriverRegistration;

/* native driver registration functions. These functions are auto-generated */
void *registerNativeDriver(nNIKAL100_tDriver*);
void unregisterNativeDriver(void*);

int init_module(void)
{
   atomicDriver.module = THIS_MODULE;

   if (nNIAPAL200_driverEntry(&atomicDriver))
      return -ENODEV;

   nativeDriverRegistration = registerNativeDriver(&atomicDriver);

   if (nativeDriverRegistration == NULL)
   {
      if (atomicDriver.unload)
         atomicDriver.unload(&atomicDriver);
      return -ENODEV;
   }

   return 0;
}

void cleanup_module(void)
{
   unregisterNativeDriver(nativeDriverRegistration);

   if (atomicDriver.unload)
      atomicDriver.unload(&atomicDriver);
}

/* native driver registration is no-op */
void *registerNativeDriver(struct nNIKAL100_tDriver* ignore)
{
   static int some_non_null_storage_ignoreme;
   return &some_non_null_storage_ignoreme;
}
void unregisterNativeDriver(void* ignore) { }


#define nNIKAL100_mExportSymbol EXPORT_SYMBOL
extern int nistreamkNotifyUserProcessIsDetached;
nNIKAL100_mExportSymbol(nistreamkNotifyUserProcessIsDetached);
extern int nistreamkUnregisterDeviceInternal;
nNIKAL100_mExportSymbol(nistreamkUnregisterDeviceInternal);
extern int nistreamkNotifySinkEndpointEventOccurred;
nNIKAL100_mExportSymbol(nistreamkNotifySinkEndpointEventOccurred);
extern int nistreamkNotifySourceEndpointEventOccurred;
nNIKAL100_mExportSymbol(nistreamkNotifySourceEndpointEventOccurred);
extern int nistreamkUnregisterEndpointInternal;
nNIKAL100_mExportSymbol(nistreamkUnregisterEndpointInternal);
extern int nistreamkRegisterEndpointInternal;
nNIKAL100_mExportSymbol(nistreamkRegisterEndpointInternal);
extern int nistreamkRegisterDeviceInternal;
nNIKAL100_mExportSymbol(nistreamkRegisterDeviceInternal);
extern int nistreamkDisableStreamFromPeerDriver;
nNIKAL100_mExportSymbol(nistreamkDisableStreamFromPeerDriver);
extern int nistreamkRemoveEndpointFromAllActiveStreams;
nNIKAL100_mExportSymbol(nistreamkRemoveEndpointFromAllActiveStreams);
extern int nistreamkUnreserveEndpoints;
nNIKAL100_mExportSymbol(nistreamkUnreserveEndpoints);
extern int nistreamkEnumeratePeers;
nNIKAL100_mExportSymbol(nistreamkEnumeratePeers);
extern int nistreamkDisableUserModeInterrupt;
nNIKAL100_mExportSymbol(nistreamkDisableUserModeInterrupt);
extern int nistreamkSetAttribute;
nNIKAL100_mExportSymbol(nistreamkSetAttribute);
extern int nistreamkGetAttribute;
nNIKAL100_mExportSymbol(nistreamkGetAttribute);
extern int nistreamkEnableStream;
nNIKAL100_mExportSymbol(nistreamkEnableStream);
extern int nistreamkGetDeviceInfo;
nNIKAL100_mExportSymbol(nistreamkGetDeviceInfo);
extern int nistreamkEnumerateEndpoints;
nNIKAL100_mExportSymbol(nistreamkEnumerateEndpoints);
extern int nistreamkReserveEndpoints;
nNIKAL100_mExportSymbol(nistreamkReserveEndpoints);
extern int nistreamkLinkStream;
nNIKAL100_mExportSymbol(nistreamkLinkStream);
extern int nistreamkWaitOnInterrupt;
nNIKAL100_mExportSymbol(nistreamkWaitOnInterrupt);
extern int nistreamkGetUserModeInterruptInfo;
nNIKAL100_mExportSymbol(nistreamkGetUserModeInterruptInfo);
extern int nistreamkEnableHWInterrupt;
nNIKAL100_mExportSymbol(nistreamkEnableHWInterrupt);
extern int nistreamkUnlinkStream;
nNIKAL100_mExportSymbol(nistreamkUnlinkStream);
extern int nistreamkClearHWInterrupt;
nNIKAL100_mExportSymbol(nistreamkClearHWInterrupt);
extern int nistreamkEnableUserModeInterrupt;
nNIKAL100_mExportSymbol(nistreamkEnableUserModeInterrupt);
extern int nistreamkInitiateFlushAndDisable;
nNIKAL100_mExportSymbol(nistreamkInitiateFlushAndDisable);
extern int nistreamkDisableStream;
nNIKAL100_mExportSymbol(nistreamkDisableStream);
